if not AltManager then return end

local quests_old, questsC = { }, { }

function AltManager:QuestUpdateHandle()
		local quests = self:ScanQuestLog()
		
		if tC(quests_old) > tC(quests) then
			-- Lost a quest
			for k,v in pairs(quests_old) do
				if not (quests[k]) then
					if questsC[k] then
						self:Quest_Completed(k)
						questsC[k] = false
					else
						self:Quest_Abandoned(k)
					end
				end
			end
		elseif tC(quests_old) < tC(quests) then
			-- Gained a quest
			for k,v in pairs(quests) do
				if not (quests_old[k]) then
					self:Quest_Gained(k)
				end
			end
		end
		
		quests_old = quests
	-- end
end

function AltManager:ScanQuestLog()
	local i = 1
	local questsByID = {}
	while GetQuestLogTitle(i) do
		local questTitle, _, questTag, _, isHeader, _, isComplete, isDaily, questID = GetQuestLogTitle(i)
		if not isHeader then 
			questsByID[questID] = questTitle
			if isComplete then questsC[questID] = true end
		end
		i = i + 1
	end
	return questsByID
end

function AltManager:ScanQuestLogForDailies()
	local i = 1
	local questsByID = { }
	while GetQuestLogTitle(i) do
		local questTitle, _, questTag, _, isHeader, _, isComplete, isDaily, questID = GetQuestLogTitle(i)
		if not isHeader and isDaily and self:IsQuestTrackable(questID) then 
			questsByID[questID] = questTitle
			if isComplete then questsC[questID] = true end
		end
		i = i + 1
	end
	return questsByID
end

function tC(array)
	if (array) then
		local i = 0
		for k,v in pairs(array) do
			i = i+1
		end
		return i
	end
	return 0
end